[OCaml] Formatting
[oota-llvm.git] / utils / buildit / build_llvm
1 #!/bin/sh
2 # LLVM LOCAL file B&I
3
4 set -x
5
6 # Build LLVM the "Apple way".
7 # Parameters:
8
9 # The first parameter is a space-separated list of the architectures the
10 # compilers will run on. For instance, "ppc i386". If the current machine
11 # isn't in the list, it will (effectively) be added.
12 HOSTS="$1"
13
14 # The second parameter is a space-separated list of the architectures the
15 # compilers will generate code for. If the current machine isn't in the list, a
16 # compiler for it will get built anyway, but won't be installed.
17 # FIXME: The list of targets is currently hard-coded and TARGETS is not used.
18 TARGETS="$2"
19
20 # The third parameter is the path to the compiler sources. There should be a
21 # shell script named 'configure' in this directory. This script makes a copy...
22 ORIG_SRC_DIR="$3"
23
24 # The fourth parameter is the location where the LLVM will be installed. You can
25 # move it once it's built, so this mostly controls the layout of $DEST_DIR.
26 DEST_ROOT="$4"
27
28 # The fifth parameter is the place where the compiler will be copied once it's
29 # built.
30 DEST_DIR="$5"
31
32 # The sixth parameter is a directory in which to place information (like
33 # unstripped executables and generated source files) helpful in debugging the
34 # resulting compiler.
35 SYM_DIR="$6"
36
37 # The seventh parameter is a yes/no that indicates whether assertions should be
38 # enabled in the LLVM libs/tools.
39 LLVM_ASSERTIONS="$7"
40
41 # The eighth parameter is a yes/no that indicates whether this is an optimized
42 # build.
43 LLVM_OPTIMIZED="$8"
44
45 # A yes/no parameter that controls whether to cross-build for an ARM host.
46 ARM_HOSTED_BUILD="$9"
47
48 # A yes/no parameter that controls whether to cross-build for the iOS simulator
49 IOS_SIM_BUILD="${10}"
50
51 # The version number of the submission, e.g. 1007.
52 LLVM_SUBMIT_VERSION="${11}"
53
54 # The subversion number of the submission, e.g. 03.
55 LLVM_SUBMIT_SUBVERSION="${12}"
56
57 # The current working directory is where the build will happen. It may already
58 # contain a partial result of an interrupted build, in which case this script
59 # will continue where it left off.
60 DIR=`pwd`
61
62 DARWIN_VERS=`uname -r | sed 's/\..*//'`
63 echo DARWIN_VERS = $DARWIN_VERS
64
65 ################################################################################
66 # Run the build.
67
68 # Create the source tree we'll actually use to build, deleting
69 # tcl since it doesn't actually build properly in a cross environment
70 # and we don't really need it.
71 SRC_DIR=$DIR/src
72 rm -rf $SRC_DIR || exit 1
73 mkdir $SRC_DIR || exit 1
74 ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
75 # We can't use the top-level Makefile as-is.  Remove the soft link:
76 rm $SRC_DIR/Makefile || exit 1
77 # Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
78 sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
79
80 SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/.*\.\([0-9]*\).*/\1/'`
81 if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
82     LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
83     RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
84     LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
85 fi
86 if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
87     LLVM_VERSION="$LLVM_SUBMIT_VERSION"
88 else
89     LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
90 fi
91
92 # Figure out how many make processes to run.
93 SYSCTL=`sysctl -n hw.activecpu`
94 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
95 # Builders can default to 2, since even if they are single processor,
96 # nothing else is running on the machine.
97 if [ -z "$SYSCTL" ]; then
98     SYSCTL=2
99 fi
100 JOBS_FLAG="-j $SYSCTL"
101
102 COMMON_CONFIGURE_OPTS="\
103   --prefix=$DEST_DIR$DEST_ROOT \
104   --enable-assertions=$LLVM_ASSERTIONS \
105   --enable-optimized=$LLVM_OPTIMIZED \
106   --disable-bindings \
107   --disable-zlib \
108   --enable-terminfo=no"
109
110 COMMON_MAKEFLAGS="\
111   UNIVERSAL=1 \
112   UNIVERSAL_SDK_PATH=$SDKROOT \
113   NO_RUNTIME_LIBS=1 \
114   DISABLE_EDIS=1 \
115   REQUIRES_RTTI=1 \
116   DEBUG_SYMBOLS=1 \
117   LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
118   LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
119   VERBOSE=1"
120
121 # Build the LLVM tree universal.
122 mkdir -p $DIR/obj-llvm || exit 1
123 cd $DIR/obj-llvm || exit 1
124
125 if [ "$ARM_HOSTED_BUILD" = yes ]; then
126   # The cross-tools' build process expects to find an existing cross toolchain
127   # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
128   rm -rf $DIR/bin || exit 1
129   mkdir $DIR/bin || exit 1
130   for prog in ar nm ranlib strip lipo ld as ; do
131     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
132     T=`xcrun -sdk $SDKROOT -find ${prog}`
133     ln -s $T $DIR/bin/$prog
134     echo '#!/bin/sh' > $P || exit 1
135     echo 'exec '$T' "$@"' >> $P || exit 1
136     chmod a+x $P || exit 1
137   done
138   # Set up the links for clang.
139   for prog in clang clang++ ; do
140     P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
141     T=`xcrun -sdk $SDKROOT -find ${prog}`
142     ln -s $T $DIR/bin/$prog
143     echo '#!/bin/sh' > $P || exit 1
144     echo 'exec '$T' -arch armv7 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
145     chmod a+x $P || exit 1
146   done
147
148   PATH=$DIR/bin:$PATH
149
150   unset SDKROOT && \
151   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS \
152     --enable-targets=arm \
153     --host=arm-apple-darwin10 \
154     --target=arm-apple-darwin10 \
155     --build=i686-apple-darwin10 \
156     --program-prefix="" \
157     || exit 1
158
159   if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
160     COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
161       DEPLOYMENT_TARGET=-mios-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
162   fi
163
164   make $JOBS_FLAG $COMMON_MAKEFLAGS SDKROOT= UNIVERSAL_ARCH="$HOSTS" \
165     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
166   if [ $? != 0 ] ; then
167     echo "error: LLVM 'make' failed!"
168     exit 1
169   fi 
170
171 else
172 # not $ARM_HOSTED_BUILD
173
174   export CC=`xcrun -find clang`
175   export CXX=`xcrun -find clang++`
176
177   if [ "$IOS_SIM_BUILD" = yes ]; then
178     # Use a non-standard "darwin_sim" host triple to trigger a cross-build.
179     configure_opts="--enable-targets=x86 --host=i686-apple-darwin_sim \
180                     --build=i686-apple-darwin10"
181     if [ -n "$IPHONEOS_DEPLOYMENT_TARGET" ]; then
182       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
183         DEPLOYMENT_TARGET=-mios-simulator-version-min=$IPHONEOS_DEPLOYMENT_TARGET"
184     fi
185   else
186     configure_opts="--enable-targets=arm,x86"
187     if [ -n "$MACOSX_DEPLOYMENT_TARGET" ]; then
188       COMMON_MAKEFLAGS="$COMMON_MAKEFLAGS \
189         DEPLOYMENT_TARGET=-mmacosx-version-min=$MACOSX_DEPLOYMENT_TARGET"
190     fi
191   fi
192
193   if [ $SDKROOT ]; then
194     CPPFLAGS="$CPPFLAGS -isysroot $SDKROOT"
195   fi
196   for host in $HOSTS; do :; done
197   CPPFLAGS="$CPPFLAGS -arch $host"
198
199   $SRC_DIR/configure $COMMON_CONFIGURE_OPTS $configure_opts \
200     --program-prefix="" \
201     CPPFLAGS="$CPPFLAGS" \
202     || exit 1
203
204   make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" \
205     CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'"
206   if [ $? != 0 ] ; then
207     echo "error: LLVM 'make' failed!"
208     exit 1
209   fi 
210 fi 
211
212 ################################################################################
213 # Construct the actual destination root, by copying stuff from $DIR/dst-* to
214 # $DEST_DIR, with occasional 'lipo' commands.
215
216 cd $DEST_DIR || exit 1
217
218 # Clean out DEST_DIR in case -noclean was passed to buildit.
219 rm -rf * || exit 1
220
221 cd $DIR/obj-llvm || exit 1
222
223 # Install the tree into the destination directory.
224 make $JOBS_FLAG $COMMON_MAKEFLAGS UNIVERSAL_ARCH="$HOSTS" install
225 if ! test $? == 0 ; then
226     echo "error: LLVM 'make install' failed!"
227     exit 1
228 fi 
229
230 # Install Version.h
231 LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
232 if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
233     LLVM_MINOR_VERSION=0
234 fi
235 RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
236 echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
237 echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
238
239 # Run unifdef to preprocess the installed headers to reflect whether this
240 # was a debug or release build.
241 for file in `find $DEST_DIR$DEST_ROOT/include -type f -print`; do
242   if [ "$LLVM_ASSERTIONS" = yes ]; then
243     unifdef -UNDEBUG -D_DEBUG -o $file $file
244   else
245     unifdef -DNDEBUG -U_DEBUG -ULLVM_ENABLE_DUMP -o $file $file
246   fi
247 done
248
249 # Find the right version of strip to use.
250 STRIP=strip
251 if [ -n "$SDKROOT" ]; then
252   STRIP=`xcrun -sdk $SDKROOT -find strip`
253 fi
254
255 if [ "x$LLVM_DEBUG" != "x1" ]; then
256     # Strip local symbols from llvm libraries.
257     #
258     # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
259     # PPC objects!
260     $STRIP -Sl $DEST_DIR$DEST_ROOT/lib/*.[oa]
261     for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
262         $STRIP -Sxl $f
263     done
264 fi
265
266 # Remove .dir files 
267 cd $DEST_DIR$DEST_ROOT
268 rm -f bin/.dir etc/llvm/.dir lib/.dir
269
270 # The Hello dylib is an example of how to build a pass.
271 # The BugpointPasses module is only used to test bugpoint.
272 # These unversioned dylibs cause verification failures, so do not install them.
273 # (The wildcards are used to match a "lib" prefix if it is present.)
274 rm $DEST_DIR$DEST_ROOT/lib/*LLVMHello.dylib
275 rm $DEST_DIR$DEST_ROOT/lib/*BugpointPasses.dylib
276
277 # Compress manpages
278 MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
279 gzip -f $MDIR/*
280
281 ################################################################################
282 # Create SYM_DIR with information required for debugging.
283
284 # Figure out how many make processes to run.
285 SYSCTL=`sysctl -n hw.activecpu`
286
287 # hw.activecpu only available in 10.2.6 and later
288 if [ -z "$SYSCTL" ]; then
289   SYSCTL=`sysctl -n hw.ncpu`
290 fi
291
292 # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
293 # can default to 2, since even if they are single processor, nothing else is
294 # running on the machine.
295 if [ -z "$SYSCTL" ]; then
296   SYSCTL=2
297 fi
298
299 cd $SYM_DIR || exit 1
300
301 # Clean out SYM_DIR in case -noclean was passed to buildit.
302 rm -rf * || exit 1
303
304 # Generate .dSYM files
305 DSYMUTIL=`xcrun -find dsymutil`
306 find $DEST_DIR -perm -0111 -type f \
307     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
308     -print | xargs -n 1 -P ${SYSCTL} ${DSYMUTIL}
309
310 # Save .dSYM files and .a archives
311 cd $DEST_DIR || exit 1
312 find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
313     | cpio -pdml $SYM_DIR || exit 1
314
315 # Save source files.
316 mkdir $SYM_DIR/src || exit 1
317 cd $DIR || exit 1
318 find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
319     | cpio -pdml $SYM_DIR/src || exit 1
320
321 ################################################################################
322 # Remove libLTO.dylib and lto.h.  Those are installed by clang.
323
324 cd $DEST_DIR$DEST_ROOT
325 rm -f lib/libLTO.dylib
326 rm -f lib/libLTO.a lib/libLTO.la
327 find $DEST_DIR$DEST_ROOT -name lto.h -delete
328
329 ################################################################################
330 # Remove debugging information from DEST_DIR.
331
332 cd $DIR || exit 1
333
334 find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
335 find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
336
337 # Strip debugging information from files
338 #
339 # Use '-l' to strip i386 modules. N.B. that flag doesn't work with kext or
340 # PPC objects!
341 find $DEST_DIR -perm -0111 -type f \
342     ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config \) \
343     -print | xargs -n 1 -P ${SYSCTL} $STRIP -arch all -Sl
344
345 chgrp -h -R wheel $DEST_DIR
346 chgrp -R wheel $DEST_DIR
347
348 ################################################################################
349 # Remove the docs directory
350
351 rm -rf $DEST_DIR$DEST_ROOT/docs
352
353 ################################################################################
354 # w00t! Done!
355
356 exit 0